//----------------------------------------------------------------------------------
//aviutlvOC w͈̓Rs[
// Copyright (c) 2005  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <tchar.h>

#include "filter.h"

#define ARRAYSIZE(a)  (sizeof(a)/sizeof((a)[0]))
#define ID_SETREF  1121

#define N_CACHE 4
//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
int ref_n = -1;

//---------------------------------------------------------------------
//tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 5
TCHAR *track_name[] = { "", "", "", "", "" };
int   track_default[] = { 1, 0, 0, 640, 480 };
int   track_s[] = { 1, 0, 0, 0, 0 };
int   track_e[] = { 16, 2048, 2048, 2048, 2048 };
enum  { T_SEC, T_LEFT, T_TOP, T_WIDTH, T_HEIGHT };

#define CHECK_N 2
TCHAR *check_name[] = { "\", "LbVŒ" };
int    check_default[] = { 0, 1 };
enum { C_DISP, C_CACHE };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION | FILTER_FLAG_WINDOW_SIZE | FILTER_FLAG_EX_DATA,
  320, 206,
  "w͈̓Rs[",
  TRACK_N, track_name, track_default, track_s, track_e,
  CHECK_N, check_name, check_default,
  func_proc,
  NULL, NULL, NULL,
  func_WndProc,
  NULL, NULL,
  &ref_n,
  sizeof(ref_n),
  "w͈̓Rs[ by N099, ver1.1a",
  NULL,  NULL,

};

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  return &filter;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
  int top = fp->track[T_TOP];
  int left = fp->track[T_LEFT];
  int i,j,k,h,w;
  PIXEL_YC *ycp, *src, *dst;
  PIXEL_YC yc;
  static TCHAR buff[256];

  k = fp->check[C_CACHE] ? N_CACHE : fp->track[T_SEC];
  if(!fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->max_w, fpip->h, k, 0))
    return FALSE;

  //Rs[̃t[ԍ\
  if(ref_n >= 0 && !fp->exfunc->is_saving(fpip->editp)){
    _sntprintf(buff, ARRAYSIZE(buff), _T("%s ref:%d/%d"),
               filter.name, ref_n, fpip->frame_n );
    buff[ ARRAYSIZE(buff) - 1] = 0;
    SetWindowText(fp->hwnd, buff);
  }

  //Rs[̈
  h = top + fp->track[T_HEIGHT];
  w = left + fp->track[T_WIDTH];
  h = h>fpip->h ? fpip->h : h;
  w = w>fpip->w ? fpip->w : w;
  
  //͈͕\
  if(fp->check[C_DISP] && !fp->exfunc->is_saving(fpip->editp)){
    for(i=top ; i<h; ++i){
      ycp = fpip->ycp_edit + i*fpip->max_w + left;
      for(j=left ; j<w; ++j){
        yc = *ycp;
        yc.y = 4095 - yc.y;
        yc.cb = - yc.cb;
        yc.cr = - yc.cr;
        *ycp= yc;
        ++ycp;
      }
    }
    
    return TRUE;
  }

  //Qƃt[ݒ肳ĂȂƂ͏Ȃ
  if(ref_n < 0 || ref_n >=  fpip->frame_n)
    return TRUE;

  //QƂt[ł͏Ȃ
  if(fpip->frame >= ref_n && fpip->frame < ref_n + fp->track[T_SEC])
    return TRUE;

  //Qƌt[vZ
  k = fpip->frame - (ref_n + fp->track[T_SEC]);
  k %= fp->track[T_SEC];
  k += ref_n;

  //̖{
  ycp = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, k, NULL, NULL);
  if(NULL == ycp) return FALSE;
  
  for(i=top ; i<h; ++i){
    src = ycp + i*fpip->max_w + left;
    dst = fpip->ycp_edit + i*fpip->max_w + left;
    for(j=left ; j<w; ++j){
      *dst = *src;
      ++dst;
      ++src;
    }
  }
  
  return TRUE;
}

//---------------------------------------------------------------------
//   ݒEBhE
//---------------------------------------------------------------------
BOOL func_WndProc( HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp )
{
  UNREFERENCED_PARAMETER(editp);
	
  switch(msg){
  case WM_COMMAND:
    switch(HIWORD(wparam)){
    case BN_CLICKED:
      switch(LOWORD(wparam)){
      case ID_SETREF:
        if(fp->exfunc->is_filter_active(fp)){
          ref_n = fp->exfunc->get_frame(editp);
        }
        break;
      default:
        return FALSE;
      }
      SetFocus(NULL);
      SetFocus(hwnd);
      return fp->exfunc->is_filter_active(fp);
    }
    break;
  case WM_FILTER_INIT:
    CreateWindow(_T("BUTTON"), _T("source frame"),
                 WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
                 185, 150,
                 120, 26,
                 hwnd, (HMENU)ID_SETREF, fp->dll_hinst, NULL);
  }
  
  return FALSE;
}



